import 'package:flutter/services.dart';
import 'package:gmalpha_flutter/base/base.dart';
import 'package:gmalpha_flutter/repo/setting_respository.dart';

class SettingProvide extends BaseProvide {
  final repo = new SettingRepo();

  bool isModifyAll = false;
  int listSize = 4;

  int color = 0xffFFFFFF;

  bool canClick = true;

  String name;
  String city;
  String email;
  String headUrl;
  String userId;
  bool bindIns = true;

  String tempName;
  String tempCity;
  String tempHeadUrl;

  Map args;

  init(Map args) {
    headUrl = args["headUrl"];
    city = args["cityName"];
    name = args["name"];
    userId = args["userId"];
    if (city == null) {
      city = "请选择国家";
    }
    if (args["bindIns"] == "true") {
      bindIns = true;
      listSize = 4;
    } else {
      bindIns = false;
      listSize = 3;
    }
  }

  void setSaveBtnStatus() {
    if (tempName != name && tempCity != city && tempHeadUrl != headUrl) {
      isModifyAll = true;
    } else {
      isModifyAll = false;
    }
    notifyListeners();
  }

  void quitLogin() {
    headUrl = "http://pic26.nipic.com/20121221/9252150_142515375000_2.jpg";
    color = 0xff000000;
    notifyListeners();
//    repo.quitLogin();
  }

  void clickCity() {
    repo.clickCity();
  }

  void clickIns() {
    if (bindIns) {
      repo.clickIns();
    } else {
      clickArguement();
    }
  }

  void loadData() =>
      repo.loadData("1", "1").listen((data) {}).onError((error) {});

  void clickArguement() {
    repo.clickArguement();
  }

  void clickLeft() {
    color = 0xff000000;
    notifyListeners();
  }
}
