import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:gmalpha_flutter/base/base.dart';
import 'package:gmalpha_flutter/macros/ALColors.dart';
import 'package:gmalpha_flutter/model/setting_model.dart';
import 'package:flutter_boost/flutter_boost.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:provider/provider.dart';

class SettingPage extends StatefulWidget {
  Map args;

  SettingPage(this.args) {
    print(args);
  }

//  @override
//  Widget buildContent(BuildContext context) => _HomeContentPage();
//
//  @override
//  ChangeNotifier getProvider() {
//    var settingProvide = SettingProvide();
//    settingProvide.init(args);
//    return settingProvide;
//  }

//  @override
//  Widget build(BuildContext context)=>_HomeContentPage();

  @override
  State<StatefulWidget> createState() => _HomeContentState();
}

class _HomeContentState extends State<SettingPage> {
  TextEditingController textEditingController = TextEditingController();

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
    textEditingController.dispose();
  }

  var settingProvide = SettingProvide();

  @override
  Widget build(BuildContext context) {
//    return ChangeNotifierProvider.value(value: settingProvide
//    ,child: getMainView(),);
    return getMainView();
  }

  getMainView() {
    return Scaffold(
      appBar: new AppBar(
        elevation: 0,
        brightness: Brightness.light,
        leading: GestureDetector(
          onTap: () => clickAction(),
          child: Padding(
            padding: EdgeInsets.fromLTRB(10, 0, 0, 0),
            child: ImageIcon(AssetImage("images/nav_back.png")),
          ),
        ),

//        leading: new GestureDetector(
//            child: new ImageIcon(
//              AssetImage('images/nav_back.png'),
//              color: ALColors.Color323232,
//            ),
//            onTap: () {
//              FlutterBoost.singleton.closePageForContext(context);
//            }),[]
        actions: <Widget>[
          Container(
            padding: EdgeInsets.fromLTRB(0, 0, 30, 0),
            child: Text(
              "保存",
              style: TextStyle(
                  fontSize: 14,
                  color: Color(Provider.of<SettingProvide>(context).color)),
            ),
          )

//      Container(
//      height: double.infinity,
//        padding: EdgeInsets.fromLTRB(0, 0, 30, 0),
//        child: Center(
//            child: Provider
//                .of<SettingProvide>(context)
//                .isModifyAll
//                ? Text(
//              "保存",
//              style:
//              TextStyle(fontSize: 14, color: Color(0xffC4C4C4)),
//            )
//                : Text(
//              "保存",
//              style: TextStyle(fontSize: 14, color: Colors.black),
//            )),
//      )
        ],
      ),
      body: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: <Widget>[

          Container(
            padding: EdgeInsets.fromLTRB(29, 10, 0, 0),
            child: Text(
              "设置",
              style: TextStyle(fontSize: 30, color: Color(0xff323232)),
            ),
          ),
          Container(
            padding: EdgeInsets.fromLTRB(29, 33, 0, 33),
            child: Container(
              width: 128,
              height: 128,
              child: Stack(
                alignment: AlignmentDirectional.bottomEnd,
                children: <Widget>[
                  ClipOval(
                    child: Provider.of<SettingProvide>(context).headUrl != null
                        ? CachedNetworkImage(
                            width: double.maxFinite,
                            height: double.maxFinite,
                            imageUrl:
                                Provider.of<SettingProvide>(context).headUrl,
                            placeholder: (context, url) {
                              return Image.asset(
                                  "images/icon_default_head.png");
                            },
                            fit: BoxFit.cover,
                          )
                        : Image.asset("images/icon_default_head.png"),
                  ),
                  Image.asset("images/camera.png"),
                ],
              ),
            ),
          ),
          Container(
            height: 240,
            child: ListView.separated(
                padding: EdgeInsets.fromLTRB(30, 0, 30, 0),
                itemCount: Provider.of<SettingProvide>(context).listSize,
                itemBuilder: (BuildContext context, int index) {
                  if (index == 0) {
                    return specialOneItem(context, "昵称", index);
                  } else if (index == 1) {
                    return ListItemView(context, "国家",
                        Provider.of<SettingProvide>(context).city, index);
                  } else if (index == 2) {
                    if (Provider.of<SettingProvide>(context).bindIns) {
                      return ListItemView(context, "我的Instagram账号",
                          Provider.of<SettingProvide>(context).email, index);
                    } else {
                      return ListItemView(context, "意见与建议", "", index);
                    }
                  } else if (index == 3) {
                    return ListItemView(context, "意见与建议", "", index);
                  }
                },
                separatorBuilder: (BuildContext context, int index) {
                  return new Divider(
                    height: 1.0,
                    color: Color(0xffE4E4E4),
                  );
                }),
          ),
          Container(
            padding: EdgeInsets.fromLTRB(30, 0, 30, 0),
            child: Divider(
              height: 1,
              indent: 0.0,
              color: Color(0xffE4E4E4),
            ),
          ),
          Expanded(
            child: Container(),
            flex: 56,
          ),
          Container(
            width: double.maxFinite,
            padding: EdgeInsets.fromLTRB(30, 0, 30, 0),
            child: OutlineButton(
              child: Text(
                "退出登入",
                style: TextStyle(color: Color(0xff323232), fontSize: 14),
              ),
              onPressed: () => Provider.of<SettingProvide>(context).quitLogin(),
            ),
          ),
          Expanded(
            child: Container(),
            flex: 30,
          ),
        ],
      ),
    );
  }

  ListItemView(BuildContext context, String left, String right, int index) {
    return Container(
        height: 60,
        child: GestureDetector(
          onTap: onListItemTap(context, index),
          child: Row(
            children: <Widget>[
              Center(
                child: Text(
                  left,
                  style: TextStyle(fontSize: 13, color: Color(0xff323232)),
                ),
              ),
              Expanded(
                child: Container(),
                flex: 1,
              ),
              Center(
                  child: right != null
                      ? Text(
                          right,
                          style:
                              TextStyle(fontSize: 13, color: Color(0xff323232)),
                        )
                      : Container()),
              Center(child: Image.asset("images/right_arrow.png"))
            ],
          ),
        ));
  }

  specialOneItem(BuildContext context, String left, int index) {
    return Container(
      height: 60,
      child: GestureDetector(
        onTap: onListItemTap(context, index),
        child: Row(
          children: <Widget>[
            Center(
              child: Text(left,
                  style: TextStyle(fontSize: 13, color: Color(0xff323232))),
            ),
            Expanded(
              child: Container(
                width: double.maxFinite,
                child: TextField(
                    controller: textEditingController,
                    textAlign: TextAlign.end,
                    style: TextStyle(fontSize: 13, color: Color(0xff323232)),
                    maxLines: 1,
                    showCursor: false,
                    onEditingComplete: () {
                      Provider.of<SettingProvide>(context).tempName =
                          textEditingController.text;
                      Provider.of<SettingProvide>(context).setSaveBtnStatus();
                    },
                    decoration: InputDecoration(
                        border: InputBorder.none,
                        hintText: Provider.of<SettingProvide>(context).tempName,
                        hintStyle:
                            TextStyle(fontSize: 13, color: Color(0xff323232)))),
              ),
            )
          ],
        ),
      ),
    );
  }

  onListItemTap(BuildContext context, int index) {
    if (index == 1) {
      //点击国家
      Provider.of<SettingProvide>(context).clickCity();
    } else if (index == 2) {
      //ins
      Provider.of<SettingProvide>(context).clickIns();
    } else if (index == 3) {
      //意见
      Provider.of<SettingProvide>(context).clickArguement();
    }
  }

  clickAction() {
    Provider.of<SettingProvide>(context).clickLeft();
  }
}

class my extends CustomPainter {
  @override
  void paint(Canvas canvas, Size size) {
    // TODO: implement paint
  }

  @override
  bool shouldRepaint(CustomPainter oldDelegate) {
    // TODO: implement shouldRepaint
    return null;
  }
}

class CircleView extends SingleChildRenderObjectWidget {
  @override
  RenderObject createRenderObject(BuildContext context) {
    return null;
  }
}

//class A extends StatefulWidget{
//
//
//  A(
//      ......
//
//      ){
//    .........
//  }
//
//
//
//  @override
//  State<StatefulWidget> createState() {
//    // TODO: implement createState
//    return null;
//  }
//
//}
//
//class st extends State{
//  @override
//  Widget build(BuildContext context) {
//
//    return Container(
//
//
//    )
//  }
//}
